jQuery(document).ready( function($) {
    var id = jQuery('input#myprefix_image_id').val();
    if (parseInt(id)) {
        jQuery('input#myprefix_logo_remove').removeClass( 'hidden' );
    }

    jQuery('input#myprefix_logo_remove').click(function(e) {
        e.preventDefault();
        // jQuery('#myprefix-preview-image').remove();
        $tag = '<img id="myprefix-preview-image" src="data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///ywAAAAAAQABAAACAUwAOw==" alt="" />';
        jQuery('#myprefix-preview-image').replaceWith( $tag );
        jQuery('#myprefix_image_id').attr('value', '');
        jQuery('input#myprefix_logo_remove').addClass( 'hidden' );
    });

    jQuery('input#myprefix_media_manager').click(function(e) {

        e.preventDefault();
        var image_frame;
        if(image_frame){
            image_frame.open();
        }
        // Define image_frame as wp.media object
        image_frame = wp.media({
            title: 'Select Media',
            multiple : false,
            library : {
                type : 'image',
            }
        });

        image_frame.on('close',function() {
            // On close, get selections and save to the hidden input
            // plus other AJAX stuff to refresh the image preview
            var selection =  image_frame.state().get('selection');
            var gallery_ids = new Array();
            var my_index = 0;
            selection.each(function(attachment) {
                gallery_ids[my_index] = attachment['id'];
                my_index++;
            });
            var ids = gallery_ids.join(",");
            if (ids) {
                jQuery('input#myprefix_image_id').val(ids);
                Refresh_Image(ids);
            } else {
                jQuery('input#myprefix_logo_remove').trigger("click");
            }
        });

        image_frame.on('open',function() {
            // On open, get the id from the hidden input
            // and select the appropiate images in the media manager
            var selection =  image_frame.state().get('selection');
            var ids = jQuery('input#myprefix_image_id').val().split(',');
            ids.forEach(function(id) {
                var attachment = wp.media.attachment(id);
                attachment.fetch();
                selection.add( attachment ? [ attachment ] : [] );
            });

        });

        image_frame.open();
    });

});

// Ajax request to refresh the image preview
function Refresh_Image(the_id){
    var data = {
        action: 'myprefix_get_image',
        id: the_id
    };

    jQuery.get(ajaxurl, data, function(response) {

        if(response.success === true) {
            jQuery('#myprefix-preview-image').replaceWith( response.data.image );
            jQuery('input#myprefix_logo_remove').removeClass( 'hidden' );
        }
    });
}